#version 120
#extension GL_ARB_shader_texture_lod : enable

/*
!! DO NOT REMOVE !! !! DO NOT REMOVE !!

This code is from Chocapic13' shaders
Read the terms of modification and sharing before changing something below please !
!! DO NOT REMOVE !! !! DO NOT REMOVE !!


Sharing and modification rules

Sharing a modified version of my shaders:
-You are not allowed to claim any of the code included in "Chocapic13' shaders" as your own
-You can share a modified version of my shaders if you respect the following title scheme : " -Name of the shaderpack- (Chocapic13' Shaders edit) "
-You cannot use any monetizing links
-The rules of modification and sharing have to be same as the one here (copy paste all these rules in your post), you cannot make your own rules
-I have to be clearly credited
-You cannot use any version older than "Chocapic13' Shaders V4" as a base, however you can modify older versions for personal use
-Common sense : if you want a feature from another shaderpack or want to use a piece of code found on the web, make sure the code is open source. In doubt ask the creator.
-Common sense #2 : share your modification only if you think it adds something really useful to the shaderpack(not only 2-3 constants changed)


Special level of permission; with written permission from Chocapic13, if you think your shaderpack is an huge modification from the original (code wise, the look/performance is not taken in account):
-Allows to use monetizing links
-Allows to create your own sharing rules
-Shaderpack name can be chosen
-Listed on Chocapic13' shaders official thread
-Chocapic13 still have to be clearly credited


Using this shaderpack in a video or a picture:
-You are allowed to use this shaderpack for screenshots and videos if you give the shaderpack name in the description/message
-You are allowed to use this shaderpack in monetized videos if you respect the rule above.


Minecraft website:
-The download link must redirect to the link given in the shaderpack's official thread
-You are not allowed to add any monetizing link to the shaderpack download

If you are not sure about what you are allowed to do or not, PM Chocapic13 on http://www.minecraftforum.net/
Not respecting these rules can and will result in a request of thread/download shutdown to the host/administrator, with or without warning. Intellectual property stealing is punished by law.
*/
#define MAX_COLOR_RANGE 48.0
const bool gcolorMipmapEnabled = true;

#define RAIN_DROPS
#define BLOOM //Makes brighter blocks eg glowstone "glow"
#define LENS_FLARE

varying vec4 texcoord;
vec3 color;
varying vec3 lightVector;
varying vec3 sunVec;
varying vec3 moonVec;
varying vec3 upVec;

varying vec3 sunlight;
varying vec3 moonlight;
varying vec3 ambient_color;

varying float eyeAdapt;
varying float sunVisibility;
varying float moonVisibility;
varying float timeMidnight;

uniform sampler2D gcolor;
uniform sampler2D gdepth;
uniform sampler2D gdepthtex;
uniform sampler2D depthtex0;
uniform sampler2D depthtex2;
uniform sampler2D gaux1;
uniform sampler2D gaux2;
uniform sampler2D gaux4;
uniform sampler2D noisetex;
uniform sampler2D composite;
uniform vec3 sunPosition;
uniform mat4 gbufferProjection;
uniform ivec2 eyeBrightnessSmooth;
uniform ivec2 eyeBrightness;
uniform int isEyeInWater;
uniform int worldTime;
uniform float aspectRatio;
uniform float near;
uniform float far;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float frameTimeCounter;
uniform float centerDepthSmooth;

vec3 sunPos = sunPosition;
float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;
float timefract = worldTime;
/*--------------------------------*/

float matflag = texture2D(gaux1,texcoord.xy).g;

float ld(float depth) {

    return (2.0 * near) / (far + near - depth * (far - near));
}

float luma(vec3 color) {
	return dot(color,vec3(0.299, 0.587, 0.114));
}

float distratio(vec2 pos, vec2 pos2) {
	float xvect = pos.x*aspectRatio-pos2.x*aspectRatio;
	float yvect = pos.y-pos2.y;
	return sqrt(xvect*xvect + yvect*yvect);
}

float gen_circular_lens(vec2 center, float size) {
	float dist=distratio(center,texcoord.xy)/size;
	return exp(-dist*dist);
}

vec2 noisepattern(vec2 pos) {
	return vec2(abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f)),abs(fract(sin(dot(pos.yx ,vec2(18.9898f,28.633f))) * 4378.5453f)));
}

float getnoise(vec2 pos) {
	return abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f));
}

float cdist(vec2 coord) {
	return max(abs(coord.s-0.5),abs(coord.t-0.5))*2.0;
}

/*vec3 alphablend(vec3 c, vec3 ac, float a) {
vec3 n_ac = normalize(ac)*(1/sqrt(3.));
vec3 nc = sqrt(c*n_ac);
return mix(c,nc,a);
}*/
float smStep (float edge0,float edge1,float x) {
float t = clamp((x - edge0) / (edge1 - edge0), 0.0, 1.0);
return t * t * (3.0 - 2.0 * t); }

float 	GetDepthLinear(in vec2 coord) {					//Function that retrieves the scene depth. 0 - 1, higher values meaning farther away
	return 2.0f * near * far / (far + near - (2.0f * texture2D(gdepthtex, coord).x - 1.0f) * (far - near));
}

float 	GetMaterialIDs(in vec2 coord) {			//Function that retrieves the texture that has all material IDs stored in it
	return texture2D(gdepth, coord).r;
}

	float distratio(vec2 pos, vec2 pos2, float ratio) {
		float xvect = pos.x*ratio-pos2.x*ratio;
		float yvect = pos.y-pos2.y;
		return sqrt(xvect*xvect + yvect*yvect);
	}

	//circle position pattern (vec2 coordinate, size)
	const vec3 pattern[16] = vec3[16](	vec3(0.1,0.1,0.02),
										vec3(-0.12,0.07,0.02),
										vec3(-0.11,-0.13,0.02),
										vec3(0.1,-0.1,0.02),

										vec3(0.07,0.15,0.02),
										vec3(-0.08,0.17,0.02),
										vec3(-0.14,-0.07,0.02),
										vec3(0.15,-0.19,0.02),

										vec3(0.012,0.15,0.02),
										vec3(-0.08,0.17,0.02),
										vec3(-0.14,-0.07,0.02),
										vec3(0.02,-0.17,0.021),

										vec3(0.10,0.05,0.02),
										vec3(-0.13,0.09,0.02),
										vec3(-0.05,-0.1,0.02),
										vec3(0.1,0.01,0.02)
									);

	float yDistAxis (in float degrees) {
		vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
			 tpos = vec4(tpos.xyz/tpos.w,1.0);
		vec2 lightPos = tpos.xy/tpos.z;
			 lightPos = (lightPos + 1.0f)/2.0f;

		return abs((lightPos.y-lightPos.x*(degrees))-(texcoord.y-texcoord.x*(degrees)));

	}

	float smoothCircleDist (in float lensDist) {

		vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
			 tpos = vec4(tpos.xyz/tpos.w,1.0);
		vec2 lightPos = tpos.xy/tpos.z*lensDist;
			 lightPos = (lightPos + 1.0f)/2.0f;

		return distratio(lightPos.xy, texcoord.xy, aspectRatio);

	}

	float cirlceDist (float lensDist, float size) {

		vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
			 tpos = vec4(tpos.xyz/tpos.w,1.0);
		vec2 lightPos = tpos.xy/tpos.z*lensDist;
			 lightPos = (lightPos + 1.0f)/2.0f;

		return pow(min(distratio(lightPos.xy, texcoord.xy, aspectRatio),size)/size,10.);
	}

	float hash( float n ) {
		return fract(sin(n)*43758.5453);
	}

	float noise( in vec2 x ) {
		vec2 p = floor(x);
		vec2 f = fract(x);
    	f = f*f*(3.0-2.0*f);
    	float n = p.x + p.y*57.0;
    	float res = mix(mix( hash(n+  0.0), hash(n+  1.0),f.x), mix( hash(n+ 57.0), hash(n+ 58.0),f.x),f.y);
    	return res;
	}

	float fbm( vec2 p ) {
    	float f = 0.0;
    	f += 0.50000*noise( p ); p = p*2.02;
    	f += 0.25000*noise( p ); p = p*2.03;
    	f += 0.12500*noise( p ); p = p*2.01;
    	f += 0.06250*noise( p ); p = p*2.04;
    	f += 0.03125*noise( p );

    	return f/0.984375;
	}


  #ifdef LENS_FLARE
  void lensFlare(){
  	vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
  		tpos = vec4(tpos.xyz/tpos.w,1.0);
  	vec2 lightPos = tpos.xy/tpos.z;
  		lightPos = (lightPos + 1.0f)/2.0f;

      float distof = min(min(1.0-lightPos.x,lightPos.x),min(1.0-lightPos.y,lightPos.y));
  	float fading = clamp(1.0-step(distof,0.1)+pow(distof*10.0,5.0),0.0,1.0);

      float time = float(worldTime);

      float sunvisibility = min(texture2D(gaux2,vec2(0.0)).a,1.0) * fading ;
  	float sunvisibility2 = min(texture2D(gaux2,vec2(0.0)).a,1.0);

  	float lensBrightness = 0.5;

  	// Fix, that the particles are visible on the moon position at daytime
  	float truepos = sign(sunPosition.z);		//1 -> sun / -1 -> moon
  	vec3 rainc = mix(vec3(1.),vec3(0.2,0.25,0.3),rainStrength);
  	vec3 lightColor = mix(sunlight*sunVisibility*rainc,6.0*moonlight*moonVisibility*rainc,truepos*0.5+0.5);

  	// Anamorphic Lens
  	if (sunvisibility > 0.01) {

  		float visibility = max(pow(max(1.0 - smoothCircleDist(1.0)/1.5,0.1),1.0)-0.1,0.0);

  		vec3 lenscolor = length(lightColor)*vec3(0.2, 0.8, 2.55);

  		float lens_strength = 0.8 * lensBrightness;
  		lenscolor *= lens_strength;

  		float anamorphic_lens = max(pow(max(1.0 - yDistAxis(0.0)/1.4,0.1),10.0)-0.7,0.0);
  		color += anamorphic_lens * lenscolor * visibility  * sunvisibility * (1.0-rainStrength*1.0) * (1-timeMidnight);

  		float dist = distance(texcoord.st, vec2(0.5, 0.5));

  		visibility = max(pow(max(1.0 - smoothCircleDist(1.0)/1.0,0.1),5.0)-0.1,0.0);
  		lenscolor = vec3(0.0);
  			if (length(lightColor) > 0.001)
  		lenscolor = pow(normalize(lightColor),vec3(2.2))*length(lightColor);


  			lens_strength = 0.7 * lensBrightness;
  			lenscolor *= lens_strength;

  			float sunray1 = max(pow(max(1.0 - yDistAxis(1.5)/0.7,0.1),10.0)-0.6,0.0);
  			float sunray2 = max(pow(max(1.0 - yDistAxis(-1.3)/0.7,0.1),10.0)-0.6,0.0);
  			float sunray3 = max(pow(max(1.0 - yDistAxis(5.0)/1.5,0.1),10.0)-0.6,0.0);
  			float sunray4 = max(pow(max(1.0 - yDistAxis(-4.8)/1.5,0.1),10.0)-0.6,0.0);

  			float sunrays = sunray1 + sunray2 + sunray3 + sunray4;

  			color += lenscolor * sunrays * visibility * sunvisibility * (1.0-rainStrength*1.0)*2 * (1-timeMidnight);

  		// Sun Glow
  		if (length(lightColor) > 0.001)
  		lenscolor = pow(normalize(lightColor),vec3(2.2))*length(lightColor)*vec3(0.7,0.75,1.);


  		lens_strength = 1.5 * lensBrightness;
  		lenscolor *= lens_strength;

  		float lensFlare = max(pow(max(1.0 - smoothCircleDist(1.0)/2.4,0.1),10.0)-0.1,0.0);

  		color += lensFlare * lenscolor * sunvisibility2 * (1.0-rainStrength*1.0) * (1-timeMidnight);

  				// Circle Lens 1
  			lenscolor =  vec3(2.52, 1.2, 0.4) * lightColor;

  			lens_strength = 0.2 * lensBrightness;
  			lenscolor *= lens_strength;

  			float lensFlare1 = max(pow(max(1.0 - cirlceDist(-0.15, 0.07)/1.0,0.1),5.0)-0.1,0.0);
  			float lensFlare2 = max(pow(max(1.0 - cirlceDist(-0.2, 0.07)/1.0,0.1),5.0)-0.1,0.0);
  			float lensFlare3 = max(pow(max(1.0 - cirlceDist(-0.25, 0.07)/1.0,0.1),5.0)-0.1,0.0);

  			lensFlare = clamp(lensFlare1 * lensFlare2 * lensFlare3, 0.0, 1.0);

  			color += lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0)*0.7 * (1-timeMidnight);

  		// Circle Lens 2
  			lenscolor =  vec3(1.6, 2.55, 0.4) * lightColor;

  			lens_strength = 0.2 * lensBrightness;
  			lenscolor *= lens_strength;

  			lensFlare1 = max(pow(max(1.0 - cirlceDist(-0.4, 0.13)/1.0,0.1),5.0)-0.1,0.0);
  			lensFlare2 = max(pow(max(1.0 - cirlceDist(-0.5, 0.13)/1.0,0.1),5.0)-0.1,0.0);
  			lensFlare3 = max(pow(max(1.0 - cirlceDist(-0.6, 0.13)/1.0,0.1),5.0)-0.1,0.0);

  			lensFlare = clamp(lensFlare1 * lensFlare2 * lensFlare3, 0.0, 1.0);

  			color += lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0)*0.7 * (1-timeMidnight);

  		// Circle Lens 3
  			lenscolor =  vec3(0.4, 2.55, 1.55) * lightColor;

  			lens_strength = 0.1 * lensBrightness;
  			lenscolor *= lens_strength;

  			lensFlare1 = max(pow(max(1.0 - cirlceDist(-0.75, 0.09)/1.0,0.1),5.0)-0.1,0.0);
  			lensFlare2 = max(pow(max(1.0 - cirlceDist(-0.8, 0.09)/1.0,0.1),5.0)-0.1,0.0);
  			lensFlare3 = max(pow(max(1.0 - cirlceDist(-0.85, 0.09)/1.0,0.1),5.0)-0.1,0.0);

  			lensFlare = clamp(lensFlare1 * lensFlare2 * lensFlare3, 0.0, 1.0);

  			color += lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0)*0.7 * (1-timeMidnight);

  		// Small point 1
  			lenscolor = vec3(2.55, 2.55, 0.0) * lightColor;

  			lens_strength = 150.0 * lensBrightness;
  			lenscolor *= lens_strength;

  			lensFlare1 = max(pow(max(1.0 - smoothCircleDist(-0.27)/1.0,0.1),5.0)-0.85,0.0);
  			lensFlare2 = max(pow(max(1.0 - smoothCircleDist(-0.3)/1.0,0.1),5.0)-0.85,0.0);
  			lensFlare3 = max(pow(max(1.0 - smoothCircleDist(-0.33)/1.0,0.1),5.0)-0.85,0.0);

  			lensFlare = clamp(lensFlare1 * lensFlare2 * lensFlare3, 0.0, 1.0);

  			color += lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0) * (1-timeMidnight);

  		// Small point 2
  			lenscolor = vec3(0.0, 1.55, 2.52) * lightColor;

  			lens_strength = 150.0 * lensBrightness;
  			lenscolor *= lens_strength;

  			lensFlare1 = max(pow(max(1.0 - smoothCircleDist(-0.82)/1.0,0.1),5.0)-0.85,0.0);
  			lensFlare2 = max(pow(max(1.0 - smoothCircleDist(-0.85)/1.0,0.1),5.0)-0.85,0.0);
  			lensFlare3 = max(pow(max(1.0 - smoothCircleDist(-0.88)/1.0,0.1),5.0)-0.85,0.0);

  			lensFlare = clamp(lensFlare1 * lensFlare2 * lensFlare3, 0.0, 1.0);

  			color += lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0) * (1-timeMidnight);

  		// Ring Lens
  			lenscolor = vec3(0.2, 0.8, 2.55) * length(lightColor);

  			lens_strength = 0.3 * lensBrightness;
  			lenscolor *= lens_strength;

  			lensFlare1 = max(pow(max(1.0 - cirlceDist(-0.7, 0.5)/1.0,0.1),5.0)-0.1,0.0);
  			lensFlare2 = max(pow(max(1.0 - cirlceDist(-0.9, 0.5)/1.0,0.1),5.0)-0.1,0.0);

  			lensFlare = clamp(lensFlare2 - lensFlare1, 0.0, 1.0);
  			color += lensFlare*lensFlare * lenscolor * sunvisibility * (1.0-rainStrength*1.0)*1.3 * (1-timeMidnight);

  	}
  }
  #endif



#ifdef FILMIC_TONEMAP
vec3 filmicToneMapping(vec3 color)
{
	color = max(vec3(0.), color - vec3(0.01));
	color = (color * (6.2 * color + .5)) / (color * (6.2 * color + 1.7) + 0.03);
	return color;
}
#endif

vec3 whitePreservingLumaBasedReinhardToneMapping(vec3 color)
{
	float white = 5.;
	float luma = dot(color, vec3(0.2126, 0.7152, 0.0722));
	float toneMappedLuma = luma * (1. + luma / (white*white)) / (1. + luma);
	color *= toneMappedLuma / luma;
  //float exposure = 1.7;
  //color *= exposure/(1. + color / exposure);
	color = pow(color, vec3(1. / 2.2));
	return color;
}


void main() {
	const float pi = 3.14159265359;
	float rainlens = 0.0;
	const float lifetime = 4.0;		//water drop lifetime in seconds
  int land = int(matflag < 0.03);
  float hand  = float(matflag > 0.75 && matflag < 0.85);
  int iswater = int(matflag > 0.04 && matflag < 0.07);

	float ftime = frameTimeCounter*2.0/lifetime;
	vec2 drop = vec2(0.0,fract(frameTimeCounter/20.0));

  	vec2 fake_refract = vec2(sin(frameTimeCounter + texcoord.x*100.0 + texcoord.y*50.0),cos(frameTimeCounter + texcoord.y*100.0 + texcoord.x*50.0)) ;
  	vec2 newTC = (texcoord.st + fake_refract * 0.01 * (rainlens+isEyeInWater*0.25));



  #ifdef RAIN_DROPS
		if (rainStrength > 0.02) {
		float gen = 1.0-fract((ftime+0.5)*0.5);
		vec2 pos = (noisepattern(vec2(-0.94386347*floor(ftime*0.5+0.25),floor(ftime*0.5+0.25))))*0.8+0.1 - drop;
		rainlens += gen_circular_lens(fract(pos),0.04)*gen*rainStrength;
		gen = 1.0-fract((ftime+1.0)*0.5);
		pos = (noisepattern(vec2(0.9347*floor(ftime*0.5+0.5),-0.2533282*floor(ftime*0.5+0.5))))*0.8+0.1- drop;
		rainlens += gen_circular_lens(fract(pos),0.023)*gen*rainStrength;
		gen = 1.0-fract((ftime+1.5)*0.5);
		pos = (noisepattern(vec2(0.785282*floor(ftime*0.5+0.75),-0.285282*floor(ftime*0.5+0.75))))*0.8+0.1- drop;
		rainlens += gen_circular_lens(fract(pos),0.03)*gen*rainStrength;
		gen =  1.0-fract(ftime*0.5);
		pos = (noisepattern(vec2(-0.347*floor(ftime*0.5),0.6847*floor(ftime*0.5))))*0.8+0.1- drop;
		rainlens += gen_circular_lens(fract(pos),0.05)*gen*rainStrength;
		rainlens *= clamp((eyeBrightnessSmooth.y-220)/15.0,0.0,1.0);
	}
  #endif

	color = pow(texture2D(gaux2, newTC).rgb,vec3(2.2))*MAX_COLOR_RANGE;


        #ifdef LENS_FLARE
        lensFlare();
        #endif

  #ifdef BLOOM
  vec3 blur = vec3(0);
  vec2 bloomcoord = texcoord.xy;

	vec3 blur1 = pow(texture2D(composite,bloomcoord/pow(2.0,2.0) + vec2(0.0,0.0)).rgb,vec3(2.2))*pow(7.0,0);
	vec3 blur2 = pow(texture2D(composite,bloomcoord/pow(2.0,3.0) + vec2(0.3,0.0)).rgb,vec3(2.2))*pow(6.0,1.0);
	vec3 blur3 = pow(texture2D(composite,bloomcoord/pow(2.0,4.0) + vec2(0.0,0.3)).rgb,vec3(2.2))*pow(5.0,1.0);
	vec3 blur4 = pow(texture2D(composite,bloomcoord/pow(2.0,5.0) + vec2(0.1,0.3)).rgb,vec3(2.2))*pow(4.0,1.0);
	vec3 blur5 = pow(texture2D(composite,bloomcoord/pow(2.0,6.0) + vec2(0.2,0.3)).rgb,vec3(2.2))*pow(3.0,1.0);
	vec3 blur6 = pow(texture2D(composite,bloomcoord/pow(2.0,7.0) + vec2(0.3,0.3)).rgb,vec3(2.2))*pow(2.0,1.0);
	blur = blur1 + blur2 + blur3 + blur4 + blur5 + blur6;
	blur = blur*pow(length(blur),0.4);
	//blur = pow(texture2D(composite,bloomcoord/2).rgb,vec3(2.2));

  color.rgb = mix(color,blur*MAX_COLOR_RANGE,0.003);
  //color = blur*MAX_COLOR_RANGE;
  //color.rgb = blur5;
  #endif

	//draw rain
	vec4 rain = pow(texture2D(gaux4,texcoord.xy),vec4(vec3(2.2),1.));
	if (length(rain) > 0.0001) {
	   rain.rgb = normalize(rain.rgb)*0.001*(0.5+length(rain.rgb)*0.25)*length(ambient_color);
	    color.rgb = ((1-(1-color.xyz/48.0)*(1-rain.xyz*rain.a))*48.0);
	}

	#ifdef RAIN_DROPS
	vec3 c_rain = rainlens*ambient_color*0.0008;
	color = (((1-(1-color.xyz/48.0)*(1-c_rain.xyz))*48.0));
	#endif

color.rgb = whitePreservingLumaBasedReinhardToneMapping(color);

float saturation = 0.9;
float avg = (color.r + color.g + color.b);
color = (((color - avg )*saturation)+avg);

  color.g = color.g - 0.03f;
 //color.b = color.b + 0.02f;
  color.r = color.r - 0.07f;
	gl_FragColor = vec4(color,1.0);
}
